"""file: rodcut.py -- correction td8, exercises about cutting rods
for maximal benefit.

"""

import random

def rodcutdyn(p,n):
  rod = [0]
  for k in range(n):
    r = 0
    for i in range(k):
      r = max(r,p[i]+rod[-i-1])
    rod.append(r)
  return rod[-1]

def rodcut(p,n):
  rod,clue = [0],[-1]
  for k in range(1,n+1):
    r,pos = 0, -1
    for i in range(1,k+1):
      t = p[i-1]+rod[-i]
      if t > r:
        r,pos = t,i
    rod.append(r)
    clue.append(pos)
  i,sol = n,[]
  while i > 0:
    sol.append(clue[i])
    i -= clue[i]
  return rod[-1],sol

prices = [1,5,8,9,10,17,17,20]
print "catalog: ", [str(i+1)+":"+str(prices[i]) for i in range(len(prices))]
for n in range(8):
  print n+1, ":", rodcut(prices[:n+1],n+1)
